# This Makefile.PL for App-RecordStream was generated by
# Dist::Zilla::Plugin::MakeMaker::Awesome 0.35.
# Don't edit it but the dist.ini and plugins used to construct it.

use strict;
use warnings;

use ExtUtils::MakeMaker;

my %WriteMakefileArgs = (
  "ABSTRACT" => "recs - A system for command-line analysis of data",
  "AUTHOR" => "Ben Bernard <perlhacker\@benjaminbernard.com>, Keith Amling <keith.amling\@gmail.com>, Thomas Sibley <tsibley\@cpan.org>",
  "CONFIGURE_REQUIRES" => {
    "ExtUtils::MakeMaker" => 0
  },
  "DISTNAME" => "App-RecordStream",
  "EXE_FILES" => [
    "bin/recs",
    "bin/recs-annotate",
    "bin/recs-assert",
    "bin/recs-chain",
    "bin/recs-collate",
    "bin/recs-decollate",
    "bin/recs-delta",
    "bin/recs-eval",
    "bin/recs-flatten",
    "bin/recs-fromapache",
    "bin/recs-fromatomfeed",
    "bin/recs-fromcsv",
    "bin/recs-fromdb",
    "bin/recs-fromjsonarray",
    "bin/recs-fromkv",
    "bin/recs-frommongo",
    "bin/recs-frommultire",
    "bin/recs-fromps",
    "bin/recs-fromre",
    "bin/recs-fromsplit",
    "bin/recs-fromtcpdump",
    "bin/recs-fromxferlog",
    "bin/recs-fromxml",
    "bin/recs-generate",
    "bin/recs-grep",
    "bin/recs-join",
    "bin/recs-multiplex",
    "bin/recs-normalizetime",
    "bin/recs-operation",
    "bin/recs-sort",
    "bin/recs-stream2table",
    "bin/recs-substream",
    "bin/recs-tocsv",
    "bin/recs-todb",
    "bin/recs-togdgraph",
    "bin/recs-tognuplot",
    "bin/recs-tohtml",
    "bin/recs-topn",
    "bin/recs-toprettyprint",
    "bin/recs-toptable",
    "bin/recs-totable",
    "bin/recs-xform"
  ],
  "LICENSE" => "mit",
  "NAME" => "App::RecordStream",
  "PREREQ_PM" => {
    "Carp" => 0,
    "Cwd" => 0,
    "Data::Dumper" => 0,
    "Date::Manip" => 0,
    "File::Basename" => 0,
    "File::Glob" => 0,
    "File::Temp" => 0,
    "FindBin" => 0,
    "Getopt::Long" => 0,
    "IO::String" => 0,
    "JSON::MaybeXS" => "1.002005",
    "Module::Pluggable::Object" => "5.1",
    "Pod::Perldoc" => 0,
    "Scalar::Util" => 0,
    "Text::Autoformat" => 0,
    "Text::CSV" => 0,
    "Tie::Array" => 0,
    "Tie::Hash" => 0
  },
  "TEST_REQUIRES" => {
    "File::Spec::Functions" => 0,
    "IPC::Open2" => 0,
    "Test::More" => "0.88"
  },
  "VERSION" => "4.0.17",
  "test" => {
    "TESTS" => "t/*.t"
  }
);

%WriteMakefileArgs = (
    %WriteMakefileArgs,
    MAN3PODS => { 'lib/App/RecordStream.pm'    => '$(INST_MAN3DIR)/RecordStream.3',,
                  'lib/App/RecordStream.pm'    => '$(INST_MAN3DIR)/recs.3',,
                  'lib/App/RecordStream/Manual/Examples.pm' => '$(INST_MAN3DIR)/recs-examples.3',,
                  'lib/App/RecordStream/Manual/Story.pm'    => '$(INST_MAN3DIR)/recs-story.3' },,
    MAN1PODS => { map { m{doc/(.+)\.pod$} ? ($_ => "\$(INST_MAN1DIR)/$1.1") : () } grep { -f and not /recs-operation/ } <doc/recs-*.pod> },
    depend   => { map { ($_ => "generate_pods") } grep { -f and not /recs-operation/ } <doc/recs-*.pod> },
    PL_FILES => { 'generate_pods.pl' => 'generate_pods' },
);

my %FallbackPrereqs = (
  "Carp" => 0,
  "Cwd" => 0,
  "Data::Dumper" => 0,
  "Date::Manip" => 0,
  "File::Basename" => 0,
  "File::Glob" => 0,
  "File::Spec::Functions" => 0,
  "File::Temp" => 0,
  "FindBin" => 0,
  "Getopt::Long" => 0,
  "IO::String" => 0,
  "IPC::Open2" => 0,
  "JSON::MaybeXS" => "1.002005",
  "Module::Pluggable::Object" => "5.1",
  "Pod::Perldoc" => 0,
  "Scalar::Util" => 0,
  "Test::More" => "0.88",
  "Text::Autoformat" => 0,
  "Text::CSV" => 0,
  "Tie::Array" => 0,
  "Tie::Hash" => 0
);

unless ( eval { ExtUtils::MakeMaker->VERSION(6.63_03) } ) {
  delete $WriteMakefileArgs{TEST_REQUIRES};
  delete $WriteMakefileArgs{BUILD_REQUIRES};
  $WriteMakefileArgs{PREREQ_PM} = \%FallbackPrereqs;
}

delete $WriteMakefileArgs{CONFIGURE_REQUIRES}
  unless eval { ExtUtils::MakeMaker->VERSION(6.52) };

WriteMakefile(%WriteMakefileArgs);
